# UnknownElement

Extends \Task

Wrapper class that holds all information necessary to create a task that did not exist when Phing started.

This has something to do with phing encountering an task XML element it is not aware of at start time. This is a situation where special steps need to be taken so that the element is then known.

author | Andreas Aderhold andi@binarycloud.com
author | Hans Lellelid hans@xmpl.org
version | $Id: 5238ec4e1da8704e3062a4c29d6e680afbe5efb0 $
package | phing

### Methods

## Constructs a UnknownElement object

    __construct( $elementName)

### Arguments

#### $elementName

``

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Return the XML element name that this <code>UnnownElement</code> handles.

    getTag() : string

### Response

`string`

The XML element name that is unknown

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## handleChild

    handleChild(\IntrospectionHelper $ih,  $parent, \UnknownElement $child, \RuntimeConfigurable $childWrapper) : boolean

### Arguments

#### $ih

`\IntrospectionHelper`

#### $parent

``

#### $child

`\UnknownElement`

#### $childWrapper

`\RuntimeConfigurable`

### Response

`boolean`

## Handle child elemets of the unknown element, if any.

    handleChildren(object $parent, object $parentWrapper)

### Arguments

#### $parent

`object`

The parent object the unknown element belongs to

#### $parentWrapper

`object`

The parent wrapper object

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Creates a named task or data type. If the real object is a task, it is configured up to the init() stage.

    makeObject(\UnknownElement $ue, \RuntimeConfigurable $w) : object

throws |

### Arguments

#### $ue

`\UnknownElement`

The unknown element to create the real object for. Must not be `null`.

#### $w

`\RuntimeConfigurable`

Ignored in this implementation.

### Response

`object`

The Task or DataType represented by the given unknown element.

## Create a named task and configure it up to the init() stage.

    makeTask(\UnknownElement $ue, \RuntimeConfigurable $w, boolean $onTopLevel = false) : \Task

throws |

### Arguments

#### $ue

`\UnknownElement`

The unknwon element to create a task from

#### $w

`\RuntimeConfigurable`

The wrapper object

#### $onTopLevel

`boolean`

Whether to treat this task as if it is top-level.

### Response

`\Task`

The freshly created task

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

### Properties

## elementName

    elementName :

### Type(s)

``

## realThing

    realThing :

### Type(s)

``

## children

    children :

### Type(s)

``

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`